Core - Task # 53688

Epic # 55070 (Accepted): Workpackages

Epic # 54260 (Accepted): WP: FAL Missing Issues / Features / API

Story # 54263 (Resolved): As an Integrator | want to have my metadata present at places when using files

Task # 52778 (Resolved): No metadata shown for Folder and Category bases collections

Status: Resolved Priority: Must have

Author: Steffen Ritter Category: File Abstraction Layer (FAL)
Created: 2013-11-16 Assigned To: Steffen Ritter

Updated: 2014-02-17 Due date: 2014-02-15

TYPO3 Version: 6.2

PHP Version:

Complexity: medium

Sprint Focus:

Subject: ResourceFactory::createFileObject is called from Folder::getFiles directly

Description

sysext/core/Resource/Folder::getFiles directly collects the files from the driver (very expensive!) and creates FileObjects directly.

These FileObjects do not know of their index record!

The method has to be restructered. With method FileIndexRepository::findByFolder (introduced with #53687) the folder's index

records can be retrieved.

- The driver already provides a method that only returns the existing identifiers instead of extracting the file's data.

- In case the IndexRecord is already present, the method calls ResourceFactory::getFile($uid, $indexRecord) otherwise

ResourceFactory::getFileObjectByStorageAndldentifier() is used.

Related issues:

follows Core - Task # 53687: FileRepository:getFilelndexRecordsForFolder only...

Resolved 2013-11-16 2013-12-31

Associated revisions

Revision 28b91ac6 - 2013-12-21 11:03 - Steffen Ritter

[BUGFIX] Folder::getFiles directly calls Factory::createFileObject

Folder::getFiles implements the logic of creating file objects
itself, after retrieving the information from the driver.

Besides the fact that this is slow since all information for the
object are received from the filesystem directly instead of the
cache in the sys_file table the uid is not present in these
objects which finally results in the lack of metadata in these
file objects.

In addition to that ommiting the ResourceFactory several objects
for the same file might exists which may lead to inconsistent
behaviour and output on modifying the file.

As the Folder/File Objects only should be a convinience facade
in front of the ResourceStorage this change introduces a new
method their, implementing the new and improved logic.

At the same time the old functionality - which enforces manual

file object creation - has been deprecated and the filelist
module is adapted accordingly.
Releases: 6.2

Resolves: #53688

Change-Id: 13fb97d432d325bd6400c0ae208b90d702c9f528d
Reviewed-on: https://review.typo3.org/26360

Reviewed-by: Frans Saris
Tested-by: Frans Saris
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History

#1 - 2013-11-30 16:15 - Steffen Ritter
- Assigned To set to Steffen Ritter

#2 - 2013-12-06 11:51 - Steffen Ritter
- Tracker changed from Bug to Task

- Due date set to 2013-12-31

- Estimated time set to 3.00

- Remaining (hours) set to 3.0

- Complexity set to medium

#3 - 2013-12-12 17:27 - Steffen Ritter
- % Done changed from 0 to 10

#4 - 2013-12-12 20:04 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26360

#5 - 2013-12-12 20:05 - Steffen Ritter
- % Done changed from 10 to 70

#6 - 2013-12-21 11:12 - Steffen Ritter
- % Done changed from 70 to 90

#7 - 2013-12-21 11:30 - Steffen Ritter

- Status changed from Under Review to Resolved
- % Done changed from 90 to 100

Applied in changeset commit:28b91ac69752be61586f52a0e0b4bf59ba7eb921.

#8 - 2013-12-21 11:59 - Steffen Ritter

- % Done changed from 100 to 90

#9 - 2014-02-17 08:57 - Steffen Ritter
- % Done changed from 90 to 100
